import { TSESTree } from "@typescript-eslint/utils";
declare type FunctionNode = TSESTree.FunctionDeclaration | TSESTree.FunctionExpression | TSESTree.ArrowFunctionExpression;
declare type ShortCircuitExpression = TSESTree.AwaitExpression | TSESTree.ReturnStatement | TSESTree.ForOfStatement;
declare const rule: import("@typescript-eslint/utils/dist/ts-eslint/Rule").RuleModule<"noAwaitBeforeReturnPromise" | "asyncCallNoAwait", never[], {
    FunctionDeclaration: (node: FunctionNode) => void;
    FunctionExpression: (node: FunctionNode) => void;
    ArrowFunctionExpression: (node: FunctionNode) => void;
    "FunctionDeclaration:exit": (node: FunctionNode) => void;
    "FunctionExpression:exit": (node: FunctionNode) => void;
    "ArrowFunctionExpression:exit": (node: FunctionNode) => void;
    AwaitExpression: (node: ShortCircuitExpression) => void;
    "AwaitExpression:exit": (node: ShortCircuitExpression) => void;
    ReturnStatement: (node: ShortCircuitExpression) => void;
    "ReturnStatement:exit": (node: ShortCircuitExpression) => void;
    'ForOfStatement[await = true]': (node: ShortCircuitExpression) => void;
    'ForOfStatement[await = true]:exit': (node: ShortCircuitExpression) => void;
    'ArrowFunctionExpression[async = true] >  AwaitExpression': (node: ShortCircuitExpression) => void;
    'ArrowFunctionExpression[async = true] >  AwaitExpression:exit': (node: ShortCircuitExpression) => void;
    CallExpression(node: TSESTree.CallExpression): void;
}>;
export default rule;
